$(document).ready(function(){
	window.url = $('body').attr("class");
	if (url.indexOf("Details") >= 0 || url.indexOf("Seasons") >= 0 || url.indexOf("Episodes") >= 0){
		$('span.rating').rating();
	}
	if(url.search(/Library$/)>=0 || url.search('Recordings')>=0){
		$('#filter').filter('ul.img, ul.music');
	}
	if (url.indexOf('Play')<0 && url.indexOf('Watch')<0 && url.indexOf('Library')>=0){
		$('#toggleWatch').css('display', 'block');
	}
	if(url.indexOf('NewMovies')>=0 || url.indexOf('Details?movie')>=0){
		$('.second').css('display', 'inline-block').children().attr('href','/MovieLibrary');
	}
	if(url.indexOf("LogOn")>=0){
		getUrlVars.hash("logon");
	}
	if (url.search('Recordings')>-1 || (url.search('TVShowsLibrary')>-1 && url.search('Details')==-1) || url.search('Episodes')|| url.search('MovieLibrary')>-1){
		$('#toggleWatch > button, #header > form > button').click(function(event){
			event.preventDefault();
			watchedToggle.init($(this));
		});
	};
	if (url.search('Play')>-1 || url.search('Watch')>-1){
		$("#header").fadeOut();
		$("#footer").css({'background' : 'none', "position" : "fixed" , "bottom" : "29px"});
		$("#content").css({
			"top":"0px",
			"bottom":"0",
			"padding-bottom":"29px",
			"overflow":"hidden",
			"position":"fixed"
		});
		$("#mediaWrap").on({
			mousemove: function(){
				if (!fadeInBuffer){
					if(hideOverlay){
						clearTimeout(hideOverlay);
						hideControls = 0;
					}
					$('#header').fadeOut();
					$('#nowplayh4, #footer').fadeIn();
					$('.ppcontrols').show(handleFade);
					$('.ppdisplay, .ppstart, #mediaWrap').css({cursor: ''});
				} else {
	            	fadeInBuffer = false;
	        	}
	        	setOverlayTimeout();
			}
		});
		$("#config").css({'display' : 'block'}).on({
			mouseover: function() {
				$(this).hide();
				$('#footer').css('pointer-events', 'none');
				$(".player").stop().show();
			}
		});
		$(".player, .player select").mouseleave(function(){
			$('.player').hide();
			$('#config').show();
			$('#footer').css('pointer-events', '');
		});
		$(".player, .player select").mouseenter(function(){
			$('#config').hide();
			$(".player").stop().show();
		});
		$("#nowplayh4").mouseover(function(){
			$(this).fadeOut();
			$("#header").fadeIn();
		});
		$("#header").mouseleave(function(){
			$(this).fadeOut();
			$("#nowplayh4").fadeIn();
		});
		$("#background").css('background',window.bgimg);
		$(window).resize( $.throttle( 50, resize_throttled.pre));
		$('#mediaspace_media_image').bind("load", pollResize());	
	};
});
window.stateLock = "IDLE";
window.hideOverlay = 0;
var fadeInBuffer = false
var startWatch = function(){	
	$('.ppcontrols').watch('position', function(){
		var position = $('.ppcontrols').css('position');
		var marginTop = $("#mediaspace").css("margin-top");
		var marginT = marginTop.slice(0,-2);
		if (marginT <= 29 && position == 'relative'){
			$('.ppcontrols').css({'position':'absolute'});
		}
		else if (marginT > 29 && position == 'absolute'){
			$('.ppcontrols').css({'position':'relative'});
		}
	});
	$('#mediaspace').watch('height', function(){
		var position = $('.ppcontrols').css('position');
		var marginTop = $("#mediaspace").css("margin-top");
		var marginT = marginTop.slice(0,-2);
		if (marginT <= 29 && position == 'relative'){
			$('.ppcontrols').css({'position':'absolute'});
		}
		else if (marginT > 29 && position == 'absolute'){
			$('.ppcontrols').css({'position':'relative'});
		}
		position = $('.ppcontrols').css('position');
		if (position == 'absolute'){
			$('#footer, .player').css({'bottom' : '29px'});
		}
		else if (marginT > 29 && marginT <= 58){
			$('#footer, .player').css({'bottom' : marginTop});
		}
		else if (marginT > 58){
			$('#footer, .player').css({'bottom' : "0"});
		}
	});
};
var resize_throttled = {
	pre: function(){
		if (stateLock == 'IDLE'){
			resize_throttled.initIdle();
		}
		else if (stateLock != 'IDLE'){
			resize_throttled.initElse();
		}
	},
	initIdle: function(){
		var ratio = (16/9);
		var $img = $('#mediaspace_media_image');
		if ( $img.width() != 0){
			ratio = $img.width()/$img.height();
			clearInterval(poll);
		}
		resize_throttled.resize(ratio);
	},
	initElse: function(){
		var ratio = (16/9);
		if (typeof videoWidth !== 'undefined'){
			ratio = videoWidth/videoHeight;
		}
		resize_throttled.resize(ratio);
	},
	resize: function(ratio){
		var oneOver = 1/(ratio);
		var newHeight = $("body").height();
		var newWidth = $("body").width();
		if (newWidth <= (newHeight*ratio)){
			$("#mediaspace").removeAttr('height').height(newWidth*oneOver);
			window.marginTop = ((newHeight - newWidth*oneOver)/2);
			$("#mediaspace").css("margin-top", marginTop);
		}
		else if (newWidth > (newHeight*ratio)){
			$("#mediaspace").removeAttr('height').height(newHeight);
			$("#mediaspace").css("margin-top","0");
		}
		window.playerWidth = $('#mediaspace').width();
		window.offsetLeft = $('#mediaspace').offset().left;
	}
};
var deleted = [];
var watchedToggle = {
	init: function(toggle){
		if ($(toggle).text() === 'Show Watched'){
			toggle.css('background','#288A3B').text('Hide Watched');
			watchedToggle.processWatched('Show', deleted);
		}
		else if ($(toggle).text() === 'Hide Watched'){
			toggle.css('background','#b94730').text('Show Watched');
			watchedToggle.processWatched('Hide');
		}
	},
	processWatched: function(action){
		console.log(window.Watched);
		var counter = 0;
		if (action === 'Hide'){
			$.each(window.Watched, function(index){
				if(window.Watched[index]==0){
					var el = $(".img").children("li:eq(" + (index-counter) + ")").detach();
					deleted.push(el);
					counter++;
				};
			});
		}
		else if (action === 'Show'){
			$.each(window.Watched, function(index){
				if(window.Watched[index]==0){
					var el = deleted.shift(el);
					$(".img").children("li:eq(" + (index) + ")").before(el);
				};
			});
		}
	}
};
$.fn.rating = function() {
	return 	$(this).html($('<span />').width(Math.max(0, (Math.min(10, parseFloat($(this).html())))) * 20));
};
$.fn.volume = function(vol) {
	return	$(this).html($('<span />').width(vol * .6));
};
window.setOverlayTimeout = function (){
    hideOverlay = setTimeout(function() {
		$('.ppcontrols, #nowplayh4, #footer, .player').fadeOut();
		$('.ppdisplay, .ppstart, #mediaWrap').css({cursor: 'none'});
		fadeInBuffer = true;
	}, 2000)
}
function seconds2time (seconds) {
    var hours   = Math.floor(seconds / 3600);
    var minutes = Math.floor((seconds - (hours * 3600)) / 60);
    var seconds = Math.floor(seconds - (hours * 3600) - (minutes * 60));
    var time = "";
    if (hours != 0) {
      time = hours+":";
    }
    if (minutes != 0 || time !== "") {
      minutes = (minutes < 10 && time !== "") ? "0"+minutes : String(minutes);
      time += minutes+":";
    }
    if (time === "") {
      time = seconds+"s";
    }
    else {
      time += (seconds < 10) ? "0"+seconds : String(seconds);
    }
    return time;
};

function idleResize() {
	$(window).resize();
};

function pollResize() {
	window.poll = setInterval(idleResize, 10 );
};
function handleFade() {
	// Clear any inline CSS properties that may be left over
    // from the fade-in / fade-out transition.
    $( this ).css({
        display: "",
        opacity: "",
        filter: "",
        zoom: ""
    });
    // If we are currently working with IE7 / IE8, then
    // clearing the inline CSS won't actually be enough. We
    // have to remove the filter attribute explicitly.
    var isIE = !! $( "html.lt-ie9" ).length;
    if ( isIE ) {
        this.style.removeAttribute( "filter" );
    }
}
var delayStop = {
	init: function(time){
		setTimeout(delayStop.stop, time);
	},
	stop: function() {
		projekktor('#mediaspace').setStop();
	}
};

var startCountdown = {
	init: function() {
		var href = window.location.href;
    	var countTime = 8;
    	var isEpisode = href.search('episode');
    	var urlBase = href.match(/^[^\x]*/);
    	var episodeNumber = href.match(/([\d]+$)|([\d]+)(?=&)/);
        startCountdown.nextEpisode(urlBase, episodeNumber, isEpisode, countTime);
    },
    nextEpisode: function(urlBase, episodeNumber, isEpisode, countTime) {
    	var newEpisodeNumber = parseInt(episodeNumber) + 1;
    	var newUrl = urlBase + "x" + newEpisodeNumber + '&autoplay=true';
    	startCountdown.trigger(isEpisode, countTime, newUrl);
    },
	trigger: function(isEpisode, countTime, newUrl) {
		if (isEpisode>-1){
			$('#countdown').show();
			var count = setInterval(function(){
				countTime--;
				$('#countdown > h3 > p').html(countTime);
				if(!countTime){
					startCountdown.end(newUrl, count);
				}
			}, 1000);
		}
	},
	end: function(newUrl, count) {
		window.location = newUrl;
		clearInterval(count);
	}
};

var getUrlVars = {
	hash: function(source) {
		var vars = [], hash;
    	var hashes = url.slice(url.indexOf('?') + 1).split('&');
   		for(var i = 0; i < hashes.length; i++)
    	{
       	 	hash = hashes[i].split('=');
      		if($.inArray(hash[0], vars)>-1)
            {
                vars[hash[0]]+=","+hash[1];
            }
            else
            {
                vars.push(hash[0]);
                vars[hash[0]] = hash[1];
            }
    	}
    	getUrlVars.sort(vars, source);
    },
    sort: function(vars, source){
    	if(source ='logon'){
    		autoLogon.init(vars);
    	}
    	if(source = 'autoplay' && vars.autoplay){
    		autoPlay.run(vars);
    	}
    }
};

var autoLogon = {
	init: function(account){
		$("#UserName").val(account.user);
		$("#Password").val(account.password);
		autoLogon.validate();
	},
	validate: function() {
		if( $("#UserName").val() && $("#Password").val() && !$(".validation-summary-errors").length ){
			$("form").submit();
		}
	}
};

var autoPlay = {
	run: function(value){
			projekktor('#mediaspace').setPlay(value.autoplay);
	}
};

var soughtTime = {
	init: function(time, sTime, type) {
		var newTime = sTime + time;
		var hours = ("0" + Math.floor(newTime/3600)).slice(-2);
		var minutes = ("0" + Math.floor((newTime-hours*3600)/60)).slice(-2);
		var secString = new String(newTime - Number(hours)*3600 - Number(minutes)*60)
		var seconds = ("0" + secString).slice(-2);
		if(type == 0){
			soughtTime.runningTime(hours, minutes, seconds);
		}
		if(type == 1){
			soughtTime.toolTip(hours, minutes, seconds);
		}
	},
	toolTip: function(h, m, s){
		$('.pphr_tip').html(h);
		$('.ppmin_tip').html(m);
		$('.ppsec_tip').html(s);
	},
	runningTime: function(h, m, s){
		$('.pphr_elp').html(h);
		$('.ppmin_elp').html(m);
		$('.ppsec_elp').html(s);
	}
};

/**
 * fastLiveFilter jQuery plugin 1.0.3
 * 
 * Copyright (c) 2011, Anthony Bush
 * License: <http://www.opensource.org/licenses/bsd-license.php>
 * Project Website: http://anthonybush.com/projects/jquery_fast_live_filter/
 **/

jQuery.fn.filter = function(list, options) {
	// Options: input, list, timeout, callback
	options = options || {};
	list = jQuery(list);
	var input = $('#filter');
	var lastFilter = '';
	var timeout = options.timeout || 0;
	var callback = options.callback || function() {};
	
	var keyTimeout;
	
	// NOTE: because we cache lis & len here, users would need to re-init the plugin
	// if they modify the list in the DOM later.  This doesn't give us that much speed
	// boost, so perhaps it's not worth putting it here.
	var lis = list.children();

	var len = lis.length;
	var oldDisplay = len > 0 ? lis[0].style.display : "block";
	callback(len); // do a one-time callback on initialization to make sure everything's in sync
	input.change(function() {
		// var startTime = new Date().getTime();
		var filterMe = input.val().toLowerCase();
		var li, innerText;
		var numShown = 0;
		for (var i = 0; i < len; i++) {
			li = lis[i];
			innerText = !options.selector ? 
				(li.textContent || li.innerText || "") : 
				$(li).find(options.selector).text();
			
			if (innerText.toLowerCase().indexOf(filterMe) >= 0) {
				if (li.style.display == "none") {
					li.style.display = oldDisplay;
				}
				numShown++;
			} else {
				if (li.style.display != "none") {
					li.style.display = "none";
				}
			}
		}
		callback(numShown);
		// var endTime = new Date().getTime();
		// console.log('Search for ' + filter + ' took: ' + (endTime - startTime) + ' (' + numShown + ' results)');
		return false;
	}).keydown(function() {
		clearTimeout(keyTimeout);
		keyTimeout = setTimeout(function() {
			if( input.val() === lastFilter ) return;
			lastFilter = input.val();
			input.change();
		}, timeout);
	});
	return this; // maintain jQuery chainability
};
/**
 * jQuery Watch Plugin
 *
 * @author Darcy Clarke
 *
 * Copyright (c) 2013 Darcy Clarke
 * Dual licensed under the MIT and GPL licenses.
 *
 * Usage:
 * $('div').watch('width height', function(){
 *   console.log(this.style.width, this.style.height);
 * });
 */

(function(e){e.fn.watch=function(t,n,r){var i=document.createElement("div");var s=window.MutationObserver||window.WebKitMutationObserver||window.MozMutationObserver;var o=window.CustomEvent||function(){return arguments||{}};var u=function(e,t){e="on"+e;var n=e in t;if(!n){t.setAttribute(e,"return;");n=typeof t[e]=="function"}return n};if(typeof n=="function"){r=n;n={}}if(typeof r!="function")r=function(){};n=e.extend({},{throttle:10},n);var a=function(t){var n=this;e.each(this.watching,function(){var e=this;var r=false;var i;for(var s=0;s<e.props.length;s++){i=t[0].attributes[e.props[s]]||t.css(e.props[s]);if(e.vals[s]!=i){e.vals[s]=i;r=true;break}}if(r&&e.callback)e.callback.call(n,new o("AttrChange"))})};return this.each(function(){var o=this;var f=e(this);var l={props:t.split(" "),vals:[],changed:[],callback:r};e.each(l.props,function(e){l.vals[e]=f[0].attributes[l.props[e]]||f.css(l.props[e]);l.changed[e]=false});if(!this.watching)this.watching=[];this.watching.push(l);if(s){var c=new s(function(e){e.forEach(function(e){r.call(o,e)})});c.observe(this,{subtree:false,attributes:true})}else if(u("DOMAttrModified",i)){f.on("DOMAttrModified",r)}else if(u("propertychange",i)){f.on("propertychange",r)}else{setInterval(function(){a.call(o,f)},n.throttle)}})}})(jQuery);
